//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "HalfToneUnit.h"
#include <jpeg.hpp>
#include "GIFImage.hpp"
#include <IniFiles.hpp>
#include "StringHelp.h"
#include "MathsHelp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THalfToneForm *HalfToneForm;
//---------------------------------------------------------------------------
__fastcall THalfToneForm::THalfToneForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THalfToneForm::PictureButtonClick(TObject *Sender)
{
    if (OpenDialog1->Execute()) {
        Edit1->Text = OpenDialog1->FileName;
        OpenDialog1->InitialDir = ExtractFilePath(Edit1->Text);
        Edit2->Text = ChangeFileExt(Edit1->Text, ".nc");
        SaveDialog1->InitialDir = ExtractFilePath(Edit1->Text);
        try {
            AnsiString Ext = ExtractFileExt(OpenDialog1->FileName).LowerCase();
            if (Ext == ".bmp" || Ext == ".jpg" || Ext == ".jpeg" || Ext == "*.emf") {
                //this round the houses methodology allows jpegs & emfs to be loaded
                TImage *TempImage = new TImage(this);
                TempImage->AutoSize = true;
                TempImage->Picture->LoadFromFile(OpenDialog1->FileName);
                Picture->Width = TempImage->Width;
                Picture->Height = TempImage->Height;
                Picture->Canvas->Draw(0,0,TempImage->Picture->Graphic);
                delete TempImage;
                }
            if (Ext == ".gif") {
                TGIFImage *Gif = new TGIFImage();
                Gif->LoadFromFile(OpenDialog1->FileName);
                Picture->Assign(Gif);
                delete Gif;
                }
            //Picture->LoadFromFile(Edit1->Text);
            //Label3->Caption = "Picture loaded and is = " + AnsiString(Picture->Width) + "W x " + AnsiString(Picture->Height) + "H Pixels";
            ConversionPossible = true;
            //RadioButton1Click(Sender);
            Edit12Change(Sender);
            }
        catch (...) {
            Label3->Caption = "Picture did not load";
            ConversionPossible = false;
            }
        }

}
//---------------------------------------------------------------------------
void __fastcall THalfToneForm::NewGCodeButtonClick(TObject *Sender)
{
    if (SaveDialog1->Execute()) {
        Edit2->Text = SaveDialog1->FileName;
        SaveDialog1->InitialDir = ExtractFilePath(Edit2->Text);
        }

}
//---------------------------------------------------------------------------
void __fastcall THalfToneForm::FormCreate(TObject *Sender)
{
    ConversionPossible = false;
    Picture = new Graphics::TBitmap();
    //Open Persistant Data & initialise variables
    TIniFile *IniFile = new TIniFile(ExtractFileDir(Application->ExeName) + "\\Data.ini");
    Edit3->Text = IniFile->ReadString("HalfTone","toolD","3.0");
    Edit4->Text = IniFile->ReadString("HalfTone","feedrate","200");
    Edit5->Text = IniFile->ReadString("HalfTone","PicX","0");
    Edit6->Text = IniFile->ReadString("HalfTone","PicY","0");
    Edit7->Text = IniFile->ReadString("HalfTone","WorkZ","0");
    Edit8->Text = IniFile->ReadString("HalfTone","FullBrightnessClearance","1");
    Edit9->Text = IniFile->ReadString("HalfTone","Size","100");
    Edit10->Text = IniFile->ReadString("HalfTone","WorkThickness","3.0");
    Edit11->Text = IniFile->ReadString("HalfTone","MaxDepthofCut","2.5");
    Edit12->Text = IniFile->ReadString("HalfTone","VAngle","30");
    Edit13->Text = IniFile->ReadString("HalfTone","toolendD","0.2");
    RadioButton1->Checked = IniFile->ReadBool("HalfTone","Width",true);
    RadioButton2->Checked = !RadioButton1->Checked;
    CheckBox1->Checked = IniFile->ReadBool("HalfTone","InvertColours",false);
    RadioGroup1->OnClick = NULL;
    RadioGroup1->ItemIndex = IniFile->ReadInteger("HalfTone","Units",0);
    RadioGroup1->OnClick = RadioGroup1Click;
    SetUnitLabels((bool) RadioGroup1->ItemIndex);
    useinches = (bool) RadioGroup1->ItemIndex;

    delete IniFile;

}
//---------------------------------------------------------------------------
void __fastcall THalfToneForm::FormDestroy(TObject *Sender)
{
    delete Picture;
    //Write Persistant Data to the shared cnc .ini file
    TIniFile *IniFile = new TIniFile(ExtractFileDir(Application->ExeName) + "\\Data.ini");
    IniFile->WriteString("HalfTone","toolD",Edit3->Text);
    IniFile->WriteString("HalfTone","feedrate",Edit4->Text);
    IniFile->WriteString("HalfTone","PicX",Edit5->Text);
    IniFile->WriteString("HalfTone","PicY",Edit6->Text);
    IniFile->WriteString("HalfTone","WorkZ",Edit7->Text);
    IniFile->WriteString("HalfTone","ZeroBrightnessClearance",Edit8->Text);
    IniFile->WriteString("HalfTone","Size",Edit9->Text);
    IniFile->WriteString("HalfTone","Depth",Edit10->Text);
    IniFile->WriteString("HalfTone","DepthofCut",Edit11->Text);
    IniFile->WriteString("HalfTone","VAngle",Edit12->Text);
    IniFile->WriteString("HalfTone","toolendD",Edit13->Text);
    IniFile->WriteBool("HalfTone","Width",RadioButton1->Checked);
    IniFile->WriteBool("HalfTone","InvertColours",CheckBox1->Checked);
    IniFile->WriteInteger("HalfTone","Units",RadioGroup1->ItemIndex);

    delete IniFile;

}
//---------------------------------------------------------------------------
void __fastcall THalfToneForm::HelpButtonClick(TObject *Sender)
{

    AnsiString temp;

    temp = "This program takes a Picture (.bmp, .jpeg, .gif or .emf), and\n";
    temp = temp + "generates a toolpath to machine a simulated halftone picture.\n\n";
    temp = temp + "To operate, select picture file name, toolpath filename,\n";
    temp = temp + "fill in all the details, then press the 'Generate' button.\n\n";
    temp = temp + "The toolpath moves to the top left of the picture and runs\n";
    temp = temp + "horizontal scanlines across the picture. Where the picture\n";
    temp = temp + "is white, the tool retracts by the set clearance.\n\n";
    temp = temp + "A V shaped tool is assumed, plunging in deep enough to\n";
    temp = temp + "fill the pixel area proportional to the darkness of the pixel.\n";
    temp = temp + "After machining, fill the holes with a dark material (wax/paint etc).\n\n";
    temp = temp + "Use the 'Invert Colours' box when creating a light image on a dark background.";
    Application->MessageBox(temp.c_str(),
                            "Help on Halftone Image Toolpath Generation Program",
                            MB_OK | MB_ICONINFORMATION);

}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::CloseButtonClick(TObject *Sender)
{
   Close();
    
}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::RadioButton1Click(TObject *Sender)
{
    //states size of halftone image if it's possible
    if (ConversionPossible) {
        double stepperpixel;
        if (RadioButton1->Checked) {
            //The machined width has been specified
            stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Width);
            } else {
            //The machined height has been specified
            stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Height);
            }
        Label3->Caption = "Halftone Image = " + DP(2,stepperpixel * (double)Picture->Width + ToDoubleDef(Edit3->Text,0.0)) + (RadioGroup1->ItemIndex ? "in W x " : "mm W x ") + DP(2,stepperpixel * (double)Picture->Height + ToDoubleDef(Edit3->Text,0.0)) + (RadioGroup1->ItemIndex ? "in" : "mm") + " H. Step per pixel = " + DP(2,stepperpixel) + (RadioGroup1->ItemIndex ? "in." : "mm.");
        }
    
}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::GenerateButtonClick(TObject *Sender)
{
    if (!Edit1->Text.Length() || !Edit2->Text.Length()) {
        Application->MessageBox("Need two file names\n\nConversion Aborted.","Warning", MB_OK | MB_ICONERROR);
        Label3->Caption = "Conversion Aborted";
        return;
        }

    if (Edit1->Text.LowerCase() == Edit2->Text.LowerCase()) {
        Application->MessageBox("Both file names the same\n\nConversion Aborted.","Warning", MB_OK | MB_ICONERROR);
        Label3->Caption = "Conversion Aborted";
        return;
        }

    if (!ConversionPossible) {
        Application->MessageBox("Please Choose a Picture\n\nConversion Aborted.","Warning", MB_OK | MB_ICONERROR);
        Label3->Caption = "Conversion Aborted";
        return;
        }

    if (FileExists(Edit1->Text) && !FileExists(Edit2->Text)) {
        TCursor oldCursor = Cursor;
        try {
            GenerateButton->Enabled = false;
            PictureButton->Enabled = false;
            NewGCodeButton->Enabled = false;
            HelpButton->Enabled = false;
            CloseButton->Enabled = false;
            Edit1->Enabled = false;
            Edit2->Enabled = false;
            Edit3->Enabled = false;
            Edit4->Enabled = false;
            Edit5->Enabled = false;
            Edit6->Enabled = false;
            Edit7->Enabled = false;
            Edit8->Enabled = false;
            Edit9->Enabled = false;
            Edit10->Enabled = false;
            Edit11->Enabled = false;
            Edit12->Enabled = false;
            Edit13->Enabled = false;
            RadioGroup1->Enabled = false;
            RadioButton1->Enabled = false;
            RadioButton2->Enabled = false;
            Cursor = crHourGlass;
            Refresh();

            TStringList *GCodeOutputFile = new TStringList();

            //int counter = 0;
            //int filelength = GCodeOutputFile->Count;
            AnsiString temp;
            int maxbrightness = 0;
            int minbrightness = 765;
            int localbrightness;
            int pixelcolour;
            int red;
            int green;
            int blue;
            int NumberofLines;

            //first loop to find out maxbrightness values
            Label3->Caption = "Checking image brightness values";
            Refresh();

            for (int i = 0; i < Picture->Width; i++) {
                for (int j = 0; j < Picture->Height; j++) {
                    pixelcolour = (int) Picture->Canvas->Pixels[i][j];
                    blue = (int) (pixelcolour / 65536);
                    green = (int) ((pixelcolour /256) - blue * 256);
                    red = (int) pixelcolour - green * 256 - blue * 65536;
                    localbrightness = red + green + blue;
                    if (localbrightness > maxbrightness) maxbrightness = localbrightness;
                    if (localbrightness < minbrightness) minbrightness = localbrightness;
                    }
                }

            if (maxbrightness > 0 && minbrightness < maxbrightness) {
                Label3->Caption = "Writing toolpath";
                Refresh();

                //second loop does the conversion work

                //double currentX;
                //double currentY;
                //double currentZ;
                double newX;
                double newY;
                double newZ;
                double lowestpoint;

                //X & Y steps per pixel
                double stepperpixel;
                if (RadioButton1->Checked) {
                    //The machined width has been specified
                    stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Width);
                    } else {
                    //The machined height has been specified
                    stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Height);
                    }

                //calculate starting position
                double startX = ToDoubleDef(Edit5->Text,0.0) + ToDoubleDef(Edit3->Text,0.0)/2.0;
                double startY = ToDoubleDef(Edit6->Text,0.0) + ToDoubleDef(Edit3->Text,0.0)/2.0 + stepperpixel * (double)Picture->Height ;

                //work height
                double workZ = ToDoubleDef(Edit7->Text,0.0);

                //tool data
                double toolendD = ToDoubleDef(Edit13->Text,0.2);
                double vangle = ToDoubleDef(Edit12->Text,30.0);

                //calculate lowest point, for brightness = 0
                lowestpoint = workZ - (1.128 * stepperpixel - toolendD)/(tanD(vangle/2.0));

                //vertical movement above lowest point for every unitary increase in brightness
                double zstepperbrightness = ((1.128 * stepperpixel - toolendD)/(tanD(vangle/2.0)))/((double)maxbrightness);
                if (zstepperbrightness < 0.0) zstepperbrightness = 0.0 - zstepperbrightness;

                //Z for clearance height over black areas
                double clearanceZ = ToDoubleDef(Edit7->Text,0.0) + ToDoubleDef(Edit8->Text,1.0);

                //Retract plane
                double retractZ = ToDoubleDef(Edit7->Text,0.0) + 3.0 * ToDoubleDef(Edit8->Text,1.0);

                //feedrate
                double feedrate = ToDoubleDef(Edit4->Text,200.0);

                //units
                bool inchUnits = (bool) RadioGroup1->ItemIndex;

                //invert colours
                bool invert = CheckBox1->Checked;

                //OK, start the Half tone image creation.
                //start of file
                GCodeOutputFile->Add("(Halftone Image Toolpath File.)");
                GCodeOutputFile->Add("(Toolpath Creation Program  R.W.Williams, 2015)");
                GCodeOutputFile->Add("(Z at top of Work = " + AnsiString(workZ)  + ")");
                GCodeOutputFile->Add("(Cutter Diameter = " + Edit3->Text  + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Cutter Vee Angle = " + Edit12->Text  + " degrees )");
                GCodeOutputFile->Add("(Feedrate = " + Edit4->Text  + (inchUnits ? " in/min )" : " mm/min )"));
                GCodeOutputFile->Add("(Picture Bottom Left Corner = X" + Edit5->Text  + " Y" + Edit6->Text + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Tool Clearance above work for White areas is " + Edit8->Text  + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Picture Size = " + AnsiString(Picture->Width) + "W, " + AnsiString(Picture->Height) + "H Pixels)");
                GCodeOutputFile->Add("(Picture Size scanned by cutter= " + DP(4,((double)Picture->Width) * stepperpixel) + "W, " + DP(4,((double)Picture->Height) * stepperpixel) + "H" + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Picture Size o/a inc. cutter = " + DP(4,((double)Picture->Width) * stepperpixel + ToDoubleDef(Edit3->Text,0.0)) + "W, " + DP(4,((double)Picture->Height) * stepperpixel + ToDoubleDef(Edit3->Text,0.0)) + "H" + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Step Per Pixel = " + DP(4,stepperpixel) + (inchUnits ? " in )" : " mm )"));
                GCodeOutputFile->Add("(Lowest point machined is with black pixels at Z" + DP(4,lowestpoint) + (inchUnits ? " in )" : " mm )"));
                if (inchUnits) {
                    GCodeOutputFile->Add("(XY Plane, Inch, Absolute distance mode, in/min feedrate)");
                    GCodeOutputFile->Add("G17 G20 G90 G94");
                    } else {
                    GCodeOutputFile->Add("(XY Plane, Metric, Absolute distance mode, mm/min feedrate)");
                    GCodeOutputFile->Add("G17 G21 G90 G94");
                    }
                GCodeOutputFile->Add("(Tool 0, Spindle 1000 rpm. Edit if needed.)");
                GCodeOutputFile->Add("T0 S1000");
                GCodeOutputFile->Add("(Move to retract plane)");
                GCodeOutputFile->Add("G0 Z" + DP(4,retractZ));
                GCodeOutputFile->Add("(Move to start position)");
                GCodeOutputFile->Add("G0 X" + DP(4,startX) + " Y" + DP(4,startY));
                GCodeOutputFile->Add("F" + DP(2,feedrate));
                GCodeOutputFile->Add("(Move to standard clearance height)");
                GCodeOutputFile->Add("G0 Z" + DP(4,clearanceZ));


                //currentX = startX;
                //currentY = startY;
                //currentZ = retractZ;

                int pixely = 0;
                while (pixely < Picture->Height) {
                    for (int pixelx = 0; pixelx < Picture->Width; pixelx++) {
                        newX = startX + stepperpixel * ((double) pixelx);
                        newY = startY - stepperpixel * ((double) pixely);
                        pixelcolour = Picture->Canvas->Pixels[pixelx][pixely];
                        blue = (int) (pixelcolour / 65536);
                        green = (int) ((pixelcolour /256) - blue * 256);
                        red = (int) pixelcolour - green * 256 - blue * 65536;
                        localbrightness = red + green + blue;
                        if (invert) localbrightness = 765 - localbrightness;
                        if (localbrightness == 765) {
                            newZ = clearanceZ;
                            } else {
                            newZ = lowestpoint + zstepperbrightness * ((double)localbrightness);
                            }
                        if (newZ != clearanceZ) {
                            GCodeOutputFile->Add("G0 X" + DP(4,newX) + " Y" + DP(4,newY));
                            GCodeOutputFile->Add("G1 Z" + DP(4,newZ));
                            GCodeOutputFile->Add("G0 Z" + DP(4,clearanceZ));
                            }
                        }
                    pixely++ ;
                    if (pixely < Picture->Height) {
                        for (int pixelx = Picture->Width - 1; pixelx > -1; pixelx--) {
                            newX = startX + stepperpixel * ((double) pixelx);
                            newY = startY - stepperpixel * ((double) pixely);
                            pixelcolour = Picture->Canvas->Pixels[pixelx][pixely];
                            blue = (int) (pixelcolour / 65536);
                            green = (int) ((pixelcolour /256) - blue * 256);
                            red = (int) pixelcolour - green * 256 - blue * 65536;
                            localbrightness = red + green + blue;
                            if (invert) localbrightness = 765 - localbrightness;
                            if (localbrightness == 765) {
                                newZ = clearanceZ;
                                } else {
                                newZ = lowestpoint + zstepperbrightness * ((double)localbrightness);
                                }
                            if (newZ != clearanceZ) {
                                GCodeOutputFile->Add("G0 X" + DP(4,newX) + " Y" + DP(4,newY));
                                GCodeOutputFile->Add("G1 Z" + DP(4,newZ));
                                GCodeOutputFile->Add("G0 Z" + DP(4,clearanceZ));
                                }
                            }
                        }
                    pixely++;
                    }


                //write G code footer
                GCodeOutputFile->Add("(Move to retract plane)");
                GCodeOutputFile->Add("G0 Z" + DP(4,retractZ));
                GCodeOutputFile->Add("(Move to start position)");
                GCodeOutputFile->Add("G0 X" + DP(4,startX) + " Y" + DP(4,startY));
                GCodeOutputFile->Add("M30");
                NumberofLines = GCodeOutputFile->Count;

                Label3->Caption = "Saving File";
                Refresh();

                GCodeOutputFile->SaveToFile(Edit2->Text);

                } else {
                Application->MessageBox("Picture is all the same colour - no detail is visible.\n\nMachining aborted","Error", MB_OK | MB_ICONERROR);
                }

            Label3->Caption = "Clearing Memory";
            Refresh();

            delete GCodeOutputFile;

            Label3->Caption = "Finished, " + AnsiString(NumberofLines) + " Lines of G Code saved.";
            Refresh();
            }

        __finally {
            GenerateButton->Enabled = true;
            PictureButton->Enabled = true;
            NewGCodeButton->Enabled = true;
            HelpButton->Enabled = true;
            CloseButton->Enabled = true;
            Edit1->Enabled = true;
            Edit2->Enabled = true;
            Edit3->Enabled = true;
            Edit4->Enabled = true;
            Edit5->Enabled = true;
            Edit6->Enabled = true;
            Edit7->Enabled = true;
            Edit8->Enabled = true;
            Edit9->Enabled = true;
            Edit10->Enabled = true;
            Edit11->Enabled = true;
            Edit12->Enabled = true;
            Edit13->Enabled = true;
            RadioGroup1->Enabled = true;
            RadioButton1->Enabled = true;
            RadioButton2->Enabled = true;
            Cursor = oldCursor;
            Refresh();
            }

        } else {
        if (FileExists(Edit1->Text)) {
            Application->MessageBox("An existing converted file will get overwritten.\n\nPlease delete file or change converted file name","Warning", MB_OK | MB_ICONERROR);
            } else {
            Application->MessageBox("The picture file does not exist.\n\nPlease check","Warning", MB_OK | MB_ICONERROR);
            }
        Label3->Caption = "Conversion Aborted";
        }

}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::SetUnitLabels(bool inches_in_use)
{
    if (!inches_in_use) {
        Label11->Caption = "Tool Diameter (mm)";
        Label4->Caption = "Plunge Feedrate (mm/min)";
        Label15->Caption = "Diameter of Tool End (mm)";
        Label5->Caption = "Picture Bottom Left X (mm)";
        Label6->Caption = "Picture Bottom Left Y (mm)";
        Label7->Caption = "Work Z (mm)";
        Label8->Caption = "Clearance from Work (mm)";
        Label9->Caption = "Work Thickness (mm)";
        Label12->Caption = "Max Depth of Cut (mm)";
        Label10->Caption = "Dimension (mm)";
        } else {
        Label11->Caption = "Tool Diameter (in)";
        Label4->Caption = "Plunge Feedrate (in/min)";
        Label15->Caption = "Diameter of Tool End (in)";
        Label5->Caption = "Picture Bottom Left X (in)";
        Label6->Caption = "Picture Bottom Left Y (in)";
        Label7->Caption = "Work Z (in)";
        Label8->Caption = "Clearance from Work (in)";
        Label9->Caption = "Work Thickness (in)";
        Label12->Caption = "Max Depth of Cut (in)";
        Label10->Caption = "Dimension (in)";
        }
}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::RadioGroup1Click(TObject *Sender)
{
    if ((bool) RadioGroup1->ItemIndex != useinches) {
        //the click has changed the units
        if (useinches) {
            //going to use mm now
            Edit3->Text = AnsiString(DP(4,ToDoubleDef(Edit3->Text,3.0) * 25.4));
            Edit4->Text = AnsiString(DP(4,ToDoubleDef(Edit4->Text,3.0) * 25.4));
            Edit13->Text = AnsiString(DP(4,ToDoubleDef(Edit13->Text,3.0) * 25.4));
            Edit5->Text = AnsiString(DP(4,ToDoubleDef(Edit5->Text,3.0) * 25.4));
            Edit6->Text = AnsiString(DP(4,ToDoubleDef(Edit6->Text,3.0) * 25.4));
            Edit7->Text = AnsiString(DP(4,ToDoubleDef(Edit7->Text,3.0) * 25.4));
            Edit8->Text = AnsiString(DP(4,ToDoubleDef(Edit8->Text,3.0) * 25.4));
            Edit10->Text = AnsiString(DP(4,ToDoubleDef(Edit10->Text,3.0) * 25.4));
            Edit11->Text = AnsiString(DP(4,ToDoubleDef(Edit11->Text,3.0) * 25.4));
            Edit9->Text = AnsiString(DP(4,ToDoubleDef(Edit9->Text,3.0) * 25.4));
            } else {
            //going to use inches now
            Edit3->Text = AnsiString(DP(4,ToDoubleDef(Edit3->Text,3.0) / 25.4));
            Edit4->Text = AnsiString(DP(4,ToDoubleDef(Edit4->Text,3.0) / 25.4));
            Edit13->Text = AnsiString(DP(4,ToDoubleDef(Edit13->Text,3.0) / 25.4));
            Edit5->Text = AnsiString(DP(4,ToDoubleDef(Edit5->Text,3.0) / 25.4));
            Edit6->Text = AnsiString(DP(4,ToDoubleDef(Edit6->Text,3.0) / 25.4));
            Edit7->Text = AnsiString(DP(4,ToDoubleDef(Edit7->Text,3.0) / 25.4));
            Edit8->Text = AnsiString(DP(4,ToDoubleDef(Edit8->Text,3.0) / 25.4));
            Edit10->Text = AnsiString(DP(4,ToDoubleDef(Edit10->Text,3.0) / 25.4));
            Edit11->Text = AnsiString(DP(4,ToDoubleDef(Edit11->Text,3.0) / 25.4));
            Edit9->Text = AnsiString(DP(4,ToDoubleDef(Edit9->Text,3.0) / 25.4));
            }
        useinches = (bool) RadioGroup1->ItemIndex;
        }
    SetUnitLabels(useinches);
}
//---------------------------------------------------------------------------

void __fastcall THalfToneForm::Edit12Change(TObject *Sender)
{
    double toolD = ToDoubleDef(Edit3->Text,0.0);
    double toolendD = ToDoubleDef(Edit13->Text,toolD);
    double vangle = ToDoubleDef(Edit12->Text,0.0);
    double stepperpixel = 1.0;
    if (!Picture->Empty) {
        if (RadioButton1->Checked) {
            //The machined width has been specified
            stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Width);
            } else {
            //The machined height has been specified
            stepperpixel = (ToDoubleDef(Edit9->Text,100.0) - ToDoubleDef(Edit3->Text,0.0))/((double)Picture->Height);
            }
        }
    double maxdoc = ToDoubleDef(Edit11->Text,0.0);
    double maxdepth;
    double workthickness = ToDoubleDef(Edit10->Text,0.0);

    if (Picture->Empty) {
        GenerateButton->Enabled = false;
        Label3->Caption = "Load Image";
        } else {
        if (toolendD >= toolD) {
            GenerateButton->Enabled = false;
            Label3->Caption = "Tool End Larger Diameter than Tool Diameter";
            } else {
            if (vangle <= 0.0) {
                GenerateButton->Enabled = false;
                Label3->Caption = "Tool Vee angle too small.";
                } else {
                if (vangle > 179.9) {
                    GenerateButton->Enabled = false;
                    Label3->Caption = "Tool Vee angle too large.";
                    } else {
                    if (stepperpixel > 0.886 * toolD) {
                        GenerateButton->Enabled = false;
                        Label3->Caption = "Either image too low resolution or machined picture too large.";
                        } else {
                        if (stepperpixel < toolendD * 1.5) {
                            GenerateButton->Enabled = false;
                            Label3->Caption = "Either image too high resolution or machined picture too small.";
                            } else {
                            maxdepth = (/*toolD*/ 1.128 * stepperpixel - toolendD)/(tanD(vangle/2.0));
                            if (maxdepth > maxdoc) {
                                GenerateButton->Enabled = false;
                                Label3->Caption = "Either 'Max depth of Cut' too small or 'Vee Angle' too small for full plunge depth.";
                                } else {
                                if (maxdoc >= workthickness) {
                                    GenerateButton->Enabled = false;
                                    Label3->Caption = "Max depth of Cut' larger than 'Work Thickness'.";
                                    } else {
                                    GenerateButton->Enabled = true;
                                    Label3->Caption = "Halftone Image = " + DP(2,stepperpixel * (double)Picture->Width + ToDoubleDef(Edit3->Text,0.0)) + (RadioGroup1->ItemIndex ? "in W x " : "mm W x ") + DP(2,stepperpixel * (double)Picture->Height + ToDoubleDef(Edit3->Text,0.0)) + (RadioGroup1->ItemIndex ? "in" : "mm") + " H. Step per pixel = " + DP(2,stepperpixel) + (RadioGroup1->ItemIndex ? "in." : "mm.");
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
}
//---------------------------------------------------------------------------

